﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Syncfusion.Linq;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;
using System.Net;
using Syncfusion.JavaScript;
using MvcApplication66.Models;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            var DataSource = new NORTHWNDEntities7().Orders.ToList();
            ViewBag.datasource = DataSource;
            var DataSource1 = OrderRepository.GetAllRecords().Take(20).ToList();
            ViewBag.datasource1 = DataSource1;
            return View();
        }
        public ActionResult DataSource(Syncfusion.JavaScript.DataManager dm)
        {
            IEnumerable Data = OrderRepository.GetAllRecords();
            Syncfusion.JavaScript.DataSources.DataOperations operation = new Syncfusion.JavaScript.DataSources.DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                Data = operation.PerformSorting(Data, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                Data = operation.PerformWhereFilter(Data, dm.Where, dm.Where[0].Operator);
                if (!dm.RequiresCounts)
                    return Json(Data); //Return records alone for the autoComplete list
            }
            int count = Data.AsQueryable().Count();
            if (dm.Skip != 0)
            {
                Data = operation.PerformSkip(Data, dm.Skip); //paging
            }
            if (dm.Take != 0)
            {
                Data = operation.PerformTake(Data, dm.Take); //paging
            }
            return Json(new { result = Data, count = count }, JsonRequestBehavior.AllowGet);
        }

    }
}

